package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _speaktext = "";
public flm.b4a.betterdialogs.BetterDialogs _bd = null;
public b4a.example.api _api = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 27;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 30;BA.debugLine="Ask(\"TITLE\", \"MESSAGE\", \"DEFAULT\")";
_ask("TITLE","MESSAGE","DEFAULT");
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 35;BA.debugLine="End Sub";
return "";
}
public static String  _activity_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_Touch (Action As Int, X As Float, Y A";
 //BA.debugLineNum = 43;BA.debugLine="Ask(\"TITLE\", \"MESSAGE\", \"DEFAULT\")";
_ask("TITLE","MESSAGE","DEFAULT");
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _ask(String _title,String _tmessage,String _default) throws Exception{
 //BA.debugLineNum = 53;BA.debugLine="Sub Ask(Title As String, tMessage As String, Defau";
 //BA.debugLineNum = 54;BA.debugLine="Return betterMSGBOX(tMessage, Title, 1, Default,";
if (true) return _bettermsgbox(_tmessage,_title,(int) (1),_default,"OK","CANCEL","");
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _ask2(String _tmessage,String _default) throws Exception{
 //BA.debugLineNum = 50;BA.debugLine="Sub Ask2(tMessage As String, Default As String) As";
 //BA.debugLineNum = 51;BA.debugLine="Return Ask(speaktext, tMessage,Default)";
if (true) return _ask(_speaktext,_tmessage,_default);
 //BA.debugLineNum = 52;BA.debugLine="End Sub";
return "";
}
public static String  _betterbutton_click() throws Exception{
anywheresoftware.b4a.objects.ButtonWrapper _btn = null;
 //BA.debugLineNum = 164;BA.debugLine="Sub BetterButton_Click";
 //BA.debugLineNum = 165;BA.debugLine="Dim Btn As Button = Sender";
_btn = new anywheresoftware.b4a.objects.ButtonWrapper();
_btn.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 166;BA.debugLine="BD.CloseDialog(Btn.Tag)";
mostCurrent._bd.CloseDialog((int)(BA.ObjectToNumber(_btn.getTag())));
 //BA.debugLineNum = 167;BA.debugLine="End Sub";
return "";
}
public static String  _bettermsgbox(String _tmessage,String _ttitle,int _inputtype,String _default,String _positivetext,String _canceltext,String _negativetext) throws Exception{
flm.b4a.betterdialogs.BetterDialogs.InputParams _ip = null;
anywheresoftware.b4a.objects.PanelWrapper _title = null;
anywheresoftware.b4a.objects.PanelWrapper _body = null;
anywheresoftware.b4a.objects.drawable.CanvasWrapper _bg2 = null;
int _colorid = 0;
int _color = 0;
int _temp = 0;
int _ret = 0;
int _barwidth = 0;
int _width = 0;
int _buttonwidth = 0;
int _buttoncount = 0;
int _whitespace = 0;
boolean _istextinput = false;
boolean _isfilelist = false;
anywheresoftware.b4a.objects.drawable.CanvasWrapper _bg = null;
int _lines = 0;
int _lineheight = 0;
int _height = 0;
int _x = 0;
int _textboxheight = 0;
flm.b4a.betterdialogs.BetterDialogs.CustomDlgParams _params = null;
anywheresoftware.b4a.objects.EditTextWrapper _textbox = null;
 //BA.debugLineNum = 70;BA.debugLine="Sub betterMSGBOX(tMessage As String, tTitle As Str";
 //BA.debugLineNum = 71;BA.debugLine="Dim IP As BD_InputBoxParams, Title As Panel, Body";
_ip = new flm.b4a.betterdialogs.BetterDialogs.InputParams();
_title = new anywheresoftware.b4a.objects.PanelWrapper();
_body = new anywheresoftware.b4a.objects.PanelWrapper();
_bg2 = new anywheresoftware.b4a.objects.drawable.CanvasWrapper();
_colorid = mostCurrent._api._lcar_randomcolor(mostCurrent.activityBA);
_color = mostCurrent._api._getcolor2(mostCurrent.activityBA,_colorid,anywheresoftware.b4a.keywords.Common.False);
_temp = 0;
_ret = 0;
 //BA.debugLineNum = 72;BA.debugLine="Dim Barwidth As Int = API.IIF(API.SmallScreen, 50";
_barwidth = (int)(Double.parseDouble(mostCurrent._api._iif(mostCurrent.activityBA,mostCurrent._api._smallscreen,BA.NumberToString(50),BA.NumberToString(100))));
_width = (int) (mostCurrent._activity.getWidth()*0.9);
_buttonwidth = 0;
_buttoncount = 0;
_whitespace = (int) (3);
 //BA.debugLineNum = 73;BA.debugLine="Dim IsTextInput As Boolean = (InputType = 1), IsF";
_istextinput = (_inputtype==1);
_isfilelist = (_inputtype==2 || _inputtype==3);
 //BA.debugLineNum = 74;BA.debugLine="Dim BG As Canvas = API.EmergencyBG";
_bg = mostCurrent._api._emergencybg(mostCurrent.activityBA);
 //BA.debugLineNum = 76;BA.debugLine="If PositiveText.Length>0 Then ButtonCount = 1";
if (_positivetext.length()>0) { 
_buttoncount = (int) (1);};
 //BA.debugLineNum = 77;BA.debugLine="If CancelText.Length>0 Then ButtonCount = ButtonC";
if (_canceltext.length()>0) { 
_buttoncount = (int) (_buttoncount+1);};
 //BA.debugLineNum = 78;BA.debugLine="If NegativeText.Length>0 Then ButtonCount = Butto";
if (_negativetext.length()>0) { 
_buttoncount = (int) (_buttoncount+1);};
 //BA.debugLineNum = 79;BA.debugLine="ButtonWidth = ((Width-Whitespace - ((Barwidth+API";
_buttonwidth = (int) (((_width-_whitespace-((_barwidth+mostCurrent._api._lcarcornerelbow2.Width+_whitespace)*2))/(double)_buttoncount));
 //BA.debugLineNum = 80;BA.debugLine="tMessage = API.TextWrap(BG, API.LCARfont, API.Fon";
_tmessage = mostCurrent._api._textwrap(mostCurrent.activityBA,_bg,mostCurrent._api._lcarfont(mostCurrent.activityBA),mostCurrent._api._fontsize,_tmessage.toUpperCase(),(int) (_width-(_barwidth+_whitespace)*2));
 //BA.debugLineNum = 81;BA.debugLine="ret=API.ItemHeight +API.LCARCornerElbow2.Height";
_ret = (int) (mostCurrent._api._itemheight+mostCurrent._api._lcarcornerelbow2.Height);
 //BA.debugLineNum = 83;BA.debugLine="Dim Lines As Int = Regex.Split(CRLF, tMessage).Le";
_lines = anywheresoftware.b4a.keywords.Common.Regex.Split(anywheresoftware.b4a.keywords.Common.CRLF,_tmessage).length;
_lineheight = (int) (mostCurrent._api._lcarfontheight+2);
_height = (int) ((_ret*2)+(_lines*_lineheight));
_x = 0;
 //BA.debugLineNum = 84;BA.debugLine="Dim TextBoxHeight As Int =API.LCARfontheight * 2,";
_textboxheight = (int) (mostCurrent._api._lcarfontheight*2);
_params = new flm.b4a.betterdialogs.BetterDialogs.CustomDlgParams();
 //BA.debugLineNum = 85;BA.debugLine="Params.Initialize";
_params.Initialize();
 //BA.debugLineNum = 89;BA.debugLine="If IsFileList Then TextBoxHeight = Activity.Heigh";
if (_isfilelist) { 
_textboxheight = (int) (mostCurrent._activity.getHeight()*0.5);};
 //BA.debugLineNum = 90;BA.debugLine="If IsTextInput OR IsFileList Then Height = Height";
if (_istextinput || _isfilelist) { 
_height = (int) (_height+_textboxheight);};
 //BA.debugLineNum = 92;BA.debugLine="IP.Initialize";
_ip.Initialize();
 //BA.debugLineNum = 94;BA.debugLine="Title.Initialize(\"\")";
_title.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 95;BA.debugLine="Activity.AddView(Title, 0,0,Width, Height)";
mostCurrent._activity.AddView((android.view.View)(_title.getObject()),(int) (0),(int) (0),_width,_height);
 //BA.debugLineNum = 96;BA.debugLine="Body.Initialize(\"\")";
_body.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 97;BA.debugLine="Activity.AddView(Body, 0,0,Width, 1)";
mostCurrent._activity.AddView((android.view.View)(_body.getObject()),(int) (0),(int) (0),_width,(int) (1));
 //BA.debugLineNum = 100;BA.debugLine="BG2.Initialize(Title)";
_bg2.Initialize((android.view.View)(_title.getObject()));
 //BA.debugLineNum = 103;BA.debugLine="X=Barwidth+API.LCARCornerElbow2.Width+Whitespace";
_x = (int) (_barwidth+mostCurrent._api._lcarcornerelbow2.Width+_whitespace);
 //BA.debugLineNum = 104;BA.debugLine="If IsTextInput Then";
if (_istextinput) { 
 //BA.debugLineNum = 105;BA.debugLine="Dim Textbox As EditText";
_textbox = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 106;BA.debugLine="Params.OpenKeyboard = IsTextInput";
_params.setOpenKeyboard(_istextinput);
 //BA.debugLineNum = 107;BA.debugLine="Textbox.Initialize(\"\")";
_textbox.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 108;BA.debugLine="Textbox.Text=Default.ToUpperCase";
_textbox.setText((Object)(_default.toUpperCase()));
 //BA.debugLineNum = 109;BA.debugLine="Textbox.Color=Colors.black";
_textbox.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 110;BA.debugLine="Textbox.SelectAll";
_textbox.SelectAll();
 //BA.debugLineNum = 111;BA.debugLine="Textbox.Typeface=API.LCARfont";
_textbox.setTypeface((android.graphics.Typeface)(mostCurrent._api._lcarfont(mostCurrent.activityBA).getObject()));
 //BA.debugLineNum = 112;BA.debugLine="Textbox.TextColor=Color";
_textbox.setTextColor(_color);
 //BA.debugLineNum = 113;BA.debugLine="Textbox.TextSize=API.Fontsize";
_textbox.setTextSize((float) (mostCurrent._api._fontsize));
 //BA.debugLineNum = 114;BA.debugLine="API.SetMargin(Textbox,0)";
mostCurrent._api._setmargin(mostCurrent.activityBA,(Object)(_textbox.getObject()),(int) (0));
 //BA.debugLineNum = 115;BA.debugLine="Title.AddView(Textbox, X, Title.Height-API.ItemH";
_title.AddView((android.view.View)(_textbox.getObject()),_x,(int) (_title.getHeight()-mostCurrent._api._itemheight-_textboxheight-_whitespace),(int) (_width-_x*2),_textboxheight);
 //BA.debugLineNum = 116;BA.debugLine="Textbox.BringToFront";
_textbox.BringToFront();
 //BA.debugLineNum = 117;BA.debugLine="Textbox.Enabled = True";
_textbox.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 118;BA.debugLine="Textbox.InputType = Textbox.INPUT_TYPE_TEXT";
_textbox.setInputType(_textbox.INPUT_TYPE_TEXT);
 //BA.debugLineNum = 119;BA.debugLine="API.DrawRect(BG2, Textbox.Left, Textbox.Top, Tex";
mostCurrent._api._drawrect(mostCurrent.activityBA,_bg2,_textbox.getLeft(),_textbox.getTop(),_textbox.getWidth(),_textbox.getHeight(),_color,_whitespace);
 };
 //BA.debugLineNum = 122;BA.debugLine="If PositiveText.Length>0 Then";
if (_positivetext.length()>0) { 
 //BA.debugLineNum = 123;BA.debugLine="Title.AddView(CreateBetterButton(DialogResponse.";
_title.AddView((android.view.View)(_createbetterbutton(anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE,_positivetext,_colorid,_buttonwidth,(int) (mostCurrent._api._itemheight-1)).getObject()),_x,(int) (_title.getHeight()-mostCurrent._api._itemheight),_buttonwidth,(int) (mostCurrent._api._itemheight-1));
 //BA.debugLineNum = 124;BA.debugLine="X=X+ButtonWidth+Whitespace";
_x = (int) (_x+_buttonwidth+_whitespace);
 };
 //BA.debugLineNum = 127;BA.debugLine="If CancelText.Length>0 Then";
if (_canceltext.length()>0) { 
 //BA.debugLineNum = 128;BA.debugLine="Title.AddView(CreateBetterButton(DialogResponse.";
_title.AddView((android.view.View)(_createbetterbutton(anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL,_canceltext,_colorid,_buttonwidth,(int) (mostCurrent._api._itemheight-1)).getObject()),_x,(int) (_title.getHeight()-mostCurrent._api._itemheight),_buttonwidth,(int) (mostCurrent._api._itemheight-1));
 //BA.debugLineNum = 129;BA.debugLine="X=X+ButtonWidth+Whitespace";
_x = (int) (_x+_buttonwidth+_whitespace);
 };
 //BA.debugLineNum = 132;BA.debugLine="If NegativeText.Length>0 Then Title.AddView(Creat";
if (_negativetext.length()>0) { 
_title.AddView((android.view.View)(_createbetterbutton(anywheresoftware.b4a.keywords.Common.DialogResponse.NEGATIVE,_negativetext,_colorid,_buttonwidth,mostCurrent._api._itemheight).getObject()),_x,(int) (_title.getHeight()-mostCurrent._api._itemheight),_buttonwidth,mostCurrent._api._itemheight);};
 //BA.debugLineNum = 139;BA.debugLine="Activity.RemoveViewAt(Activity.NumberOfViews -1)";
mostCurrent._activity.RemoveViewAt((int) (mostCurrent._activity.getNumberOfViews()-1));
 //BA.debugLineNum = 140;BA.debugLine="Activity.RemoveViewAt(Activity.NumberOfViews -1)";
mostCurrent._activity.RemoveViewAt((int) (mostCurrent._activity.getNumberOfViews()-1));
 //BA.debugLineNum = 142;BA.debugLine="Params.Background = Colors.Black";
_params.setBackground((Object)(anywheresoftware.b4a.keywords.Common.Colors.Black));
 //BA.debugLineNum = 143;BA.debugLine="Params.TitleWidth =  Title.Width";
_params.setTitleWidth(_title.getWidth());
 //BA.debugLineNum = 144;BA.debugLine="Params.TitleHeight = Title.Height";
_params.setTitleHeight(_title.getHeight());
 //BA.debugLineNum = 145;BA.debugLine="Params.Title = Title";
_params.setTitle((Object)(_title.getObject()));
 //BA.debugLineNum = 147;BA.debugLine="Params.BodyHeight = 1";
_params.setBodyHeight((int) (1));
 //BA.debugLineNum = 148;BA.debugLine="Params.BodyWidth = Title.Width";
_params.setBodyWidth(_title.getWidth());
 //BA.debugLineNum = 149;BA.debugLine="Params.DialogBody = Body";
_params.setDialogBody((Object)(_body.getObject()));
 //BA.debugLineNum = 151;BA.debugLine="ret = BD.CustomDialog(Params, \"\")";
_ret = mostCurrent._bd.CustomDialog(_params,"",mostCurrent.activityBA);
 //BA.debugLineNum = 154;BA.debugLine="If IsTextInput Then";
if (_istextinput) { 
 //BA.debugLineNum = 155;BA.debugLine="If ret = DialogResponse.Positive Then Return Tex";
if (_ret==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
if (true) return _textbox.getText();};
 //BA.debugLineNum = 156;BA.debugLine="Return \"\"' IP.CompactAnswer";
if (true) return "";
 };
 //BA.debugLineNum = 158;BA.debugLine="If IsFileList Then";
if (_isfilelist) { 
 //BA.debugLineNum = 159;BA.debugLine="If ret = DialogResponse.Positive Then Return spe";
if (_ret==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
if (true) return _speaktext;};
 //BA.debugLineNum = 160;BA.debugLine="Return \"\"";
if (true) return "";
 };
 //BA.debugLineNum = 162;BA.debugLine="Return ret";
if (true) return BA.NumberToString(_ret);
 //BA.debugLineNum = 163;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.ButtonWrapper  _createbetterbutton(int _id,String _text,int _colorid,int _width,int _height) throws Exception{
anywheresoftware.b4a.objects.drawable.StateListDrawable _bgs = null;
anywheresoftware.b4a.objects.drawable.ColorDrawable _gd1 = null;
anywheresoftware.b4a.objects.drawable.ColorDrawable _gd2 = null;
anywheresoftware.b4a.objects.ButtonWrapper _btn = null;
 //BA.debugLineNum = 168;BA.debugLine="Sub CreateBetterButton(ID As Int, Text As String,";
 //BA.debugLineNum = 169;BA.debugLine="Dim BGs As StateListDrawable, gd1 As ColorDrawabl";
_bgs = new anywheresoftware.b4a.objects.drawable.StateListDrawable();
_gd1 = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
_gd2 = new anywheresoftware.b4a.objects.drawable.ColorDrawable();
_btn = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 171;BA.debugLine="btn.Initialize(\"BetterButton\")";
_btn.Initialize(mostCurrent.activityBA,"BetterButton");
 //BA.debugLineNum = 172;BA.debugLine="btn.Tag=ID";
_btn.setTag((Object)(_id));
 //BA.debugLineNum = 173;BA.debugLine="btn.TextColor=Colors.Black";
_btn.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 174;BA.debugLine="btn.Text= Text.ToUpperCase";
_btn.setText((Object)(_text.toUpperCase()));
 //BA.debugLineNum = 175;BA.debugLine="btn.Typeface = API.LCARfont";
_btn.setTypeface((android.graphics.Typeface)(mostCurrent._api._lcarfont(mostCurrent.activityBA).getObject()));
 //BA.debugLineNum = 176;BA.debugLine="btn.TextSize = API.Fontsize";
_btn.setTextSize((float) (mostCurrent._api._fontsize));
 //BA.debugLineNum = 177;BA.debugLine="btn.Gravity = Gravity.CENTER";
_btn.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 //BA.debugLineNum = 178;BA.debugLine="Activity.AddView(btn,  0,0, Width,Height)";
mostCurrent._activity.AddView((android.view.View)(_btn.getObject()),(int) (0),(int) (0),_width,_height);
 //BA.debugLineNum = 184;BA.debugLine="BGs.Initialize";
_bgs.Initialize();
 //BA.debugLineNum = 185;BA.debugLine="gd1.Initialize( API.GetColor(ColorID, True, 255),";
_gd1.Initialize(mostCurrent._api._getcolor(mostCurrent.activityBA,_colorid,anywheresoftware.b4a.keywords.Common.True,(int) (255)),(int) (0));
 //BA.debugLineNum = 186;BA.debugLine="BGs.AddState(BGs.State_Pressed, gd1)";
_bgs.AddState(_bgs.State_Pressed,(android.graphics.drawable.Drawable)(_gd1.getObject()));
 //BA.debugLineNum = 187;BA.debugLine="gd2.Initialize( API.GetColor(ColorID, False, 255)";
_gd2.Initialize(mostCurrent._api._getcolor(mostCurrent.activityBA,_colorid,anywheresoftware.b4a.keywords.Common.False,(int) (255)),(int) (0));
 //BA.debugLineNum = 188;BA.debugLine="BGs.AddCatchAllState(gd2)";
_bgs.AddCatchAllState((android.graphics.drawable.Drawable)(_gd2.getObject()));
 //BA.debugLineNum = 189;BA.debugLine="API.SetMargin(btn,0)";
mostCurrent._api._setmargin(mostCurrent.activityBA,(Object)(_btn.getObject()),(int) (0));
 //BA.debugLineNum = 190;BA.debugLine="btn.Background  = BGs";
_btn.setBackground((android.graphics.drawable.Drawable)(_bgs.getObject()));
 //BA.debugLineNum = 191;BA.debugLine="Activity.RemoveViewAt(Activity.NumberOfViews -1)";
mostCurrent._activity.RemoveViewAt((int) (mostCurrent._activity.getNumberOfViews()-1));
 //BA.debugLineNum = 192;BA.debugLine="Return btn";
if (true) return _btn;
 //BA.debugLineNum = 193;BA.debugLine="End Sub";
return null;
}
public static String  _filelist(String _tmessage,String _title,String _startingdir,String _positive,String _cancel,String _negative,boolean _dirsonly) throws Exception{
 //BA.debugLineNum = 66;BA.debugLine="Sub FILELIST(tMessage As String, Title As String,";
 //BA.debugLineNum = 67;BA.debugLine="Return betterMSGBOX(tMessage, Title, API.IIF(Dirs";
if (true) return _bettermsgbox(_tmessage,_title,(int)(Double.parseDouble(mostCurrent._api._iif(mostCurrent.activityBA,_dirsonly,BA.NumberToString(2),BA.NumberToString(3)))),_startingdir,_positive,_cancel,_negative);
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
api._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim  BD As BetterDialogs";
mostCurrent._bd = new flm.b4a.betterdialogs.BetterDialogs();
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _msgbox1(String _tmessage,String _title) throws Exception{
 //BA.debugLineNum = 60;BA.debugLine="Sub MSGBOX1(tMessage As String, Title As String)";
 //BA.debugLineNum = 61;BA.debugLine="betterMSGBOX(tMessage,Title, 0, \"\", \"OK\", \"\",\"\")";
_bettermsgbox(_tmessage,_title,(int) (0),"","OK","","");
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static int  _msgbox3(String _tmessage,String _title,String _positive,String _cancel,String _negative) throws Exception{
 //BA.debugLineNum = 63;BA.debugLine="Sub MSGBOX3(tMessage As String, Title As String, P";
 //BA.debugLineNum = 64;BA.debugLine="Return betterMSGBOX(tMessage,Title, 0, \"\", Positi";
if (true) return (int)(Double.parseDouble(_bettermsgbox(_tmessage,_title,(int) (0),"",_positive,_cancel,_negative)));
 //BA.debugLineNum = 65;BA.debugLine="End Sub";
return 0;
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim speaktext As String";
_speaktext = "";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _qmsg(String[] _items) throws Exception{
 //BA.debugLineNum = 56;BA.debugLine="Sub qMSG(items() As String)";
 //BA.debugLineNum = 57;BA.debugLine="Return MSGBOX3(items(0), items(1), items(2), item";
if (true) return BA.NumberToString(_msgbox3(_items[(int) (0)],_items[(int) (1)],_items[(int) (2)],_items[(int) (3)],_items[(int) (4)]));
 //BA.debugLineNum = 58;BA.debugLine="End Sub";
return "";
}
}
